/*
	CCountedDictionary.h
	
	A subclass of CDictionary that can find entries by entry number.
	This is intended for AppleEvent Object Model support, and might not 
	be useful on non-Mac platforms.
	
	by James Jennings
	May 5, 1999
*/

#pragma once

#include "CDictionary.h"

class CCountedDictionary : public CDictionary {
public:
				CCountedDictionary( istream & data, istream & index )
					: CDictionary(data, index), mNumberOfEntries(0) {}

	virtual unsigned long	CountEntries();
	virtual unsigned long	GetEntryNumber() ;//const;
	virtual void			GoToEntry(unsigned long number);
	
	virtual void		BuildList();	// to be protected eventually.
protected:
	
	unsigned long				mNumberOfEntries;
	
	// the list: use off_type because it's smaller (type int)
	typedef vector<istream::off_type> Offsets;
	Offsets 	mList;
};
