/*
	CLEDictionary.cp
	
	Subclass of CDictionary that does Loglan specific things.
	Specifically, it makes complexes if more than one word is entered.
	
	by James Jennings
	Started March 21, 1999
	
*/

#include "CLEDictionary.h"
#include "ComplexMaker.h"

bool CLEDictionary::FindEntry( const char *inWord )
{	// Make a complex (if possible) and then pass to inherited

	const char * result = 0;
	ComplexMaker wm(inWord);
	
	if (wm.CanGetBest())
		result = wm.GetBestWord();
	else
		result = inWord;
	
	return CDictionary::FindEntry(result);
}
