/*
	CLEDictionary.h
	
	Subclass of CDictionary that does Loglan specific things.
	Specifically, it makes complexes if more than one word is entered.
	
	by James Jennings
	Started March 21, 1999
	
*/

#pragma once

#if __dest_os == __mac_os
	#include "CCountedDictionary.h"
	#define CDICTIONARY CCountedDictionary
#else
	#include "CDictionary.h"
	#define CDICTIONARY CDictionary
#endif

class CLEDictionary : public CDICTIONARY {
public:
				CLEDictionary( istream & data, istream & index )
					: CDICTIONARY(data, index) {}

	virtual bool FindEntry( const char *inWord );	// indexed lookup
	
};

#undef CDICTIONARY
