/*
	CLOD.cp
	
	The LOD fuctionality in one easy package.
	
	by James Jennings
	Started March 4, 1999
*/

#include "CLOD.h"

CLOD::CLOD(istream &loddata, istream &lodindex, istream &engdata, istream &engindex)
	: le(loddata, lodindex), el(engdata, engindex),
		mCurrentDictionary(noDictionary)
{
	ChooseDictionary(LE);
	if (mCurrentDictionary == noDictionary)
		ChooseDictionary(EL);
}

void	CLOD::ChooseDictionary(DictionaryType inType)
{
	switch (inType) {
	case LE:
		if (le.CanDoFind()) mCurrentDictionary = LE;
		break;
	case EL:
		if (el.CanDoFind()) mCurrentDictionary = EL;
		break;
	default:
		assert(false /* Bad DictionaryType */);
	}
}

void	CLOD::GetState( SLODState &outState ) const
{	// get the current dictionary state
	outState.which = WhichDictionary();
	GetCurrent().GetState(outState.state);
//	outState.where = GetCurrent().Peek();
//	outState.wordFound = GetCurrent().WordFound();
	GetWord(outState.word, SLODState::kMaxWordLength);
}

void	CLOD::SetState( const SLODState &inState )
{	// set the current dictionary state
	ChooseDictionary(inState.which);
	assert(WhichDictionary() == inState.which);
	
	GetCurrent().SetState(inState.state);
//	GetCurrent().Seek(inState.where);
}

