/*
	CLODHistory.h
	
	A class that tracks how a CLOD class has been used.
	
	by James Jennings
	March 22, 1999
*/

#pragma once

#include <deque>
#include "CLOD.h"

// a FIFO container for remembering a collection of dictionary states
typedef deque<SLODState> HistoryStackType;

class CLODHistory {
public:
					CLODHistory( int inMaxEntries = 10 );
	
	virtual void	RecordState( const CLOD &lod );
	virtual void	RecallState( CLOD &lod, int index );
	virtual int		CountStates();
	virtual const SLODState & GetState(int index);
	
	virtual const HistoryStackType & GetStack();

protected:
	int					maxEntries;
	HistoryStackType	stack;
};
