/*
	CHTMLFormatter.h
	
	A class for formatting an LOD entry as HTML.
	
	by James Jennings
	Started February 19, 1999
	
*/

#pragma once

#include <assert.h>
#include <stdio.h>
#include <iostream>
#include "CFormatter.h"

using namespace std;

class CHTMLFormatter : public CFormatter {
public:
				CHTMLFormatter( ostream &os = cout );
	
	virtual void BeginFormatting();
	virtual void SetStyle( EStyle inStyle );
	virtual void PutChar( char inChar );
	virtual void PutString( char *inString );
	virtual void PutNewLine();
	virtual void EndFormatting();
protected:
	ostream &out;
	EStyle mCurrent;
	char mLast;
	
	static const char * entity[128];	// list of HTML character escape codes
};
