// ===========================================================================
//	 CWord.cp				1994-1998 Loglan Institute Inc. All rights reserved.
// ===========================================================================
// Routines specific to words

/*
	JPJ:
	bestAffix and associated methods are never used?
	primType is never used?
*/

#include "CWord.h"
#include <string.h>


// ===========================================================================
//	 Constructor			1994-1998 Loglan Institute Inc. All rights reserved.
// ===========================================================================
// 
CWord::CWord()
	: affCount(0)
{
	Init();
	}
	
// ===========================================================================
//	 Destructor			1994-1998 Loglan Institute Inc. All rights reserved.
// ===========================================================================
// 

// CWord::~CWord() {}

// ===========================================================================
//	 Init			1994-1998 Loglan Institute Inc. All rights reserved.
// ===========================================================================
// Initialization

void CWord::Init()

{
	affCount = 0;
	*word = '\0';
	}

// ===========================================================================
//	 SetString				1994-1998 Loglan Institute Inc. All rights reserved.
// ===========================================================================
// a CPrim obtained from primset is used to initialize a word and count affixes

short CWord::SetString(const char *theString)

{	assert(theString != 0 && strlen(theString) <= kMaxWordLength);
	affCount = 1;
	strcpy(word,theString); // Copy the word
	primAff[0].SetString(theString);  // The first affix is the primitive itself
	
	const CPrim * thePrim = CPrimSet::Find(theString);
	if (thePrim != 0) {	// it it's a primitive in our list...
		
		// Add any other affixes. (JPJ: turned into a loop)
		for (int i=0; i<thePrim->AffixCount(); i++) {
			char buffer[CPrim::kFormLength];
			primAff[i+1].SetString(thePrim->Affix(i));
			primAff[i+1].SetForm(thePrim->GetAffixForm(i, buffer));
		}
		affCount += thePrim->AffixCount();
	}
	
	return affCount; // needed by caller.
	}
	
// ===========================================================================
//	 CalcAffixes				1994-1998 Loglan Institute Inc. All rights reserved.
// ===========================================================================
// Set up the affix values for each affix of this word

void CWord::CalcAffixes(bool isFinal)

{
	primAff[0].CalcAffix(isFinal);
	for (int j = 1; j<kMaxAffixCount; ++j) 
		primAff[j].CalcShortAffix(isFinal);
}
	
// ===========================================================================
//	 IsPredicate
// ===========================================================================
// 
bool CWord::IsPredicate( const char *w )

/* Is the word a predicate? */

{
	bool lastIsV = false;
	bool hasCC = false;
	while (*w != '\0' && isalpha(*w)) {
		bool isV = CAffix::IsVowel(*w);
		if ( !isV && !lastIsV) hasCC = true;
		lastIsV = isV;
		w++;
	}
	return hasCC && lastIsV;
}
