// ===========================================================================
//	 CWord.h		1994-1998 Loglan Institute Inc. All rights reserved.
// ===========================================================================
// Routines specific to a word

#ifndef _Wds
#define _Wds
#pragma once

#include "CAffix.h"
#include "CPrimSet.h"

class CWord {
	public:
	enum {	kMaxWordLength = 25,
			kMaxAffixCount = 4
			};
	
						CWord();
	//	virtual			~CWord();
		
		// Accessors
		char	*		GetWordText();
		CAffix 			GetPrimAffix(short theIndex);
		
		short 			SetString(const char *theString);
		void			CalcAffixes(bool isFinal); // Find the affixes
		short			GetAffCount();  // Determine the number of affixes for this word
		
		static bool		IsPredicate( const char *w );
		virtual bool	IsPredicate() const { return IsPredicate(word); }
	
	protected:
	
 		short 				affCount;	// the number of affixes for this word	
 		char 				word[kMaxWordLength+1];	// the word itself
		CAffix 				primAff[kMaxAffixCount];// the affixes for this primitive.
	private:
		// constructor shared initialization code should usually be private
		void 			Init();			// Initialization
 	
 	};
 	
 // Accessors
 	
 inline 
 short CWord::GetAffCount() { return affCount; }

 inline 
 char * CWord::GetWordText() { return word; }
 
 inline 
 CAffix CWord::GetPrimAffix(short theAffix) { return primAff[theAffix]; }
 	
 #endif
