/*
	Utility.h
*/

#include <ctype.h>

/*
	StringCopyToLowerCase()
	Copy src to dest up to maxLength, converting to lower case.
	Always terminate the string.
	Return the destination string.
*/
inline
char * StringCopyToLowerCase( char *dest, const char *src, short maxLength)
{
	const char *p = src;
	char *q = dest;
	
	while ( *p != '\0' && (p-src) < maxLength-1 )
		*(q++) = tolower(*(p++));
	*q = '\0';
	
	return dest;
}
